<template>
  <div>
    <div class="bg-indigo-300">
      <nav
        class="container px-6 py-8 mx-auto md:flex md:justify-between md:items-center"
      >
        <div class="flex items-center justify-between">
          <router-link to="/">
            <img
              class="logo-omt-blue mt-2 lg:mt-0"
              src="../assets/LogoOMTBlue.png"
              alt="logo OMT blue"
            />
          </router-link>

          <div @click="showMenu = !showMenu" class="flex md:hidden">
            <button
              type="button"
              class="text-gray-800 hover:text-yellow-600 focus:outline-none focus:text-yellow-600"
            >
              <font-awesome-icon icon="bars" size="2x" />
            </button>
          </div>
        </div>

        <ul
          :class="showMenu ? 'flex' : 'hidden'"
          class="flex-col mt-8 space-y-4 md:flex md:space-y-0 md:flex-row md:items-center md:space-x-10 md:mt-0"
        >
          <li
            class="text-m font-bold text-gray-800 hover:text-yellow-600"
            v-for="item in menuLinks"
            :key="item.textLink"
          >
            <router-link v-show="item.condition === undefined || item.condition(item)" :to="{name: item.routeName}">
              {{ item.textLink }}
            </router-link>
          </li>

          <template v-if="user.session === null">
            <li
              class="text-m font-bold text-gray-800 hover:text-yellow-600"
              v-for="item in connexionLinks"
              :key="item.textLink"
            >
              <router-link :to="{name: item.routeName}">
                {{ item.textLink }}
              </router-link>
            </li>
          </template>

          <template v-if="user.session != null">
            <li
              class="text-m font-bold text-gray-800 hover:text-yellow-600 flex md:hidden"
              v-for="item in userLinks"
              :key="item.textLink"
            >
              <router-link :to="{name: item.routeName}" v-if="item.condition === undefined || item.condition(item)">
                <font-awesome-icon
                  :icon="item.icon"
                  class="h-5 mr-2 w-5 hidden md:flex"
                />
                <span>{{ item.textLink }}</span>
              </router-link>
            </li>
            <li
              class="text-m font-bold text-gray-800 hover:text-yellow-600 flex md:hidden cursor-pointer"
              @click="user.logout"
            >
              <font-awesome-icon
                icon="sign-out-alt"
                class="h-5 mr-2 w-5 hidden md:flex"
              />
              <span>Déconnexion</span>
            </li>
          </template>

          <template v-if="user.session != null">
            <li>
              <div class="relative">
                <button
                  @click="showHideDropdown"
                  class="items-center rounded-md focus:outline-none hidden md:flex"
                >
                  <font-awesome-icon icon="user-circle" size="2x" />
                </button>

                <div
                  v-show="showDropdown"
                  class="py-2 mt-2 bg-indigo-500 rounded-md shadow-xl z-10 lg:absolute lg:right-0 w-44"
                >
                  <ul>
                    <li
                      class="block px-4 py-2 text-white hover:text-gray-800"
                      v-for="item in userLinks"
                      :key="item.textLink"
                    >
                      <router-link :to="{name: item.routeName}" v-show="item.condition === undefined || item.condition(item)">
                        <font-awesome-icon
                          :icon="item.icon"
                          class="h-5 mr-2 w-5"
                        />
                        <span>{{ item.textLink }}</span>
                      </router-link>
                    </li>
                    <li
                      class="block px-4 py-2 text-white hover:text-gray-800 cursor-pointer"
                      @click="user.logout"
                    >
                      <font-awesome-icon
                        icon="sign-out-alt"
                        class="h-5 mr-2 w-5"
                      />
                      <span>Déconnexion</span>
                    </li>
                  </ul>
                </div>
              </div>
            </li>
          </template>
        </ul>
      </nav>
    </div>
  </div>
</template>

<script>
export default {
  name: "NavBar",
  inject: ["user"],
  data() {
    return {
      showMenu: false,
      showDropdown: false,
      menuLinks: [
        { routeName: "accueil", textLink: "Accueil" },
        { routeName: "recherche-roadtrip", condition: () => this.user.session !== null ,textLink: "Créer mon road-trip"},
      ],
      connexionLinks: [
        { routeName: "inscription", textLink: "Inscription" },
        { routeName: "connexion", textLink: "Connexion" }
      ],
      userLinks: [
        {
          routeName: "dashboard-admin",
          icon: "clipboard",
          textLink: "Dashboard",
          condition: () => this.user.hasRole('SUPER_ADMIN')
        },
        {
          routeName: "mon-profil",
          icon: "user",
          textLink: "Mon profil"
        },
        {
          routeName: "roadtrips",
          icon: "road",
          textLink: "Mes trajets"
        }
      ]
    };
  },
  methods: {
    showHideDropdown: function() {
      this.showDropdown = !this.showDropdown;

      if (this.showDropdown){
        setTimeout(() => {
          this.showDropdown = false;
        }, 5000);
      }
    }
  }
};
</script>

<style scoped>
.logo-omt-blue {
  width: 3em;
  height: auto;
}
</style>
